% Generate a Pico location randomly
function [X,Y] = GenPicoPositionRandom(Xcell,Ycell,NeighborCellDistance,GuardDistPicoToeNB)

% Generate a random angle, measured from 3 o'clock counter-clockwisely
angle = 2*pi*rand;
% Find out the max distance allowed along that direction
MaxDistAllowed = NeighborCellDistance/2 / sin(pi - (angle - floor(angle/pi*3)*pi/3) - pi/3);

% Generate a random distance so that the pico will be located inside the
% hexagon along that angle
d = rand * MaxDistAllowed; % Initialization
while d > MaxDistAllowed || d < GuardDistPicoToeNB
    d = MaxDistAllowed * rand;
end

% Find out the coordinates of the Pico
X = Xcell + d * cos(angle);
Y = Ycell + d * sin(angle);